	processor p16f84
	__config 0x3ff5
	radix	dec

w	equ	0
f	equ	1

c	equ	0
dc	equ	1
z	equ	2

indf	equ	0x0
tmr0	equ	0x1
pcl	equ	0x2
status	equ	0x3
fsr	equ	0x4
porta	equ	0x5
portb	equ	0x6
eedata	equ	0x8
eeadr	equ	0x9
pclatch	equ	0xa
intcon	equ	0xb

optionr	equ	0x81
trisa	equ	0x85
trisb	equ	0x86
eecon1	equ	0x88
eecon2	equ	0x89

;----------------------------------------------
	cblock  0xc
	a3
	a2
	a1
	a0
	b3
	b2
	b1
	b0
	c3
	c2
	c1
	c0
	cnt
	endc

;------ RESET ----------------------------

	org	0
	goto ini
	org	4

ini:	movlw	0xff
	movwf	a0
	movlw   0xff
	movwf	a1
	clrf	a2
	clrf	a3
	movlw	0xff
	movwf	b0
	movlw	0xff
	movwf	b1
	clrf	b2
	clrf	b3
	call	mul32

cuel:	sleep
	goto	cuel

;------------ 32 bit multiplication -----------

mul32:	clrf	c0		; clear destination (b)
	clrf	c1
	clrf	c2
	clrf	c3
	movlw	0x20
	movwf	cnt
mulbuc:	bcf	status,c	; Shift destination (c)
	rlf	c0,f
	rlf	c1,f
	rlf	c2,f
	rlf	c3,f
	btfss	a3,7		; Test MSB (a). if 1 add b and c
	goto	mulsh

	; 32 bit add (A pain in a uC without Carry-Add!!!!)
	movf	b0,w
	addwf	c0,f
	btfss	status,c
	goto	dig1
	incfsz	c1
	goto	dig1
	incfsz	c2
	goto	dig1
	incf	c3
dig1:	movf	b1,w
	addwf	c1,f
	btfss	status,c
	goto    dig2
	incfsz	c2
	goto	dig2
	incf	c3
dig2:	movf	b2,w
	addwf	c2,f
	btfsc	status,c
	incf	c3
	movf	b3,w
	addwf	c3,f

mulsh:	; Shift (a)
	rlf	a0,f
	rlf	a1,f
	rlf	a2,f
	rlf	a3,f
	decfsz	cnt
	goto	mulbuc
	return

